#set terminal jpeg size 2500,3400 font Arial 40
set terminal png size 2000,3000 font Arial 30
set output "1-filtersteps_topflux.png"
	
####### TIME FORMAT #####
set xdata time 
set timefmt "%Y/%m/%d_%H:%M:%S" 
set format x "%d.%m" 
#set xtics rotate


####### Labels, KEY, bordersize and MARGIN #####

set ylabel ""
set key top right
set style fill solid
set lmargin 10
set rmargin 5
set border lw 3

####### LINE STYLE #####
set style line 1 lt 1 lc 1 lw 5
set style line 2 lt 1 lc 3 lw 5
set style line 3 lt 1 lc 4 lw 5
set style line 4 lt 1 lc 5 lw 5
set style line 5 lt 1 lc 6 lw 5
set style line 6 lt 1 lc 10 lw 5

####### RANGE #####
#set xrange["2013/04/20":"2013/04/30"]

set multiplot layout 6,1
set xlabel ""
set ylabel "topflux /(mm/h)

##### topflux 
plot "../output/00_signal_topflux.dat" u 2:3 w l ls 1 t "../output/unfiltered data"

##### manualfiltered
plot "../output/00_signal_topflux.dat" u 2:3 w l ls 1 t "unfiltered", "../output/01_manual_topflux.dat" u 2:3 w l ls 2 t "after manual filter"

##### thresholdfiltered
plot  "../output/01_manual_topflux.dat" u 2:3 w l ls 2 t "after manual filter",  "../output/02_threshold_topflux.dat" u 2:3 w l ls 3  t "after threshold filter"

##### median
plot "../output/02_threshold_topflux.dat" u 2:3 w l ls 3  t "after threshold filter", "../output/03a_median_topflux.dat" u 2:3 w l ls 4  t "after median filter"

##### moving mean
plot "../output/03a_median_topflux.dat" u 2:3 w l ls 4  t "after median filter", "../output/03b_runmean_topflux.dat" u 2:3 w l ls 5  t "after smoothing filter"

##### summarized threshold
set xlabel "date"
set format x "%d.%m" 

plot  "../output/03b_runmean_topflux.dat" u 2:3 w l ls 5  t "after smoothing filter", "../output/Filtered_03_topflux.dat" u 2:3 w l ls 6  t "after oscillation threshold filter"

