set terminal jpeg size 2000,3000 font Arial 34
#set terminal png size 2500,3400 font Arial 40
set output "2-filtersteps_masssum.png"

#########################################

set xdata time 
set timefmt "%Y/%m/%d_%H:%M:%S" 

set xtics rotate

set style line 1 lt 1 lc 1 lw 5
set style line 2 lt 1 lc 3 lw 5
set style line 3 lt 1 lc 4 lw 5
set style line 4 lt 1 lc 5 lw 5
set style line 5 lt 1 lc 6 lw 5
set style line 6 lt 1 lc 10 lw 5

########################################
set multiplot layout 6,1
set border lw 3

set ylabel "sum. mass (kg)"
set xlabel "time"

set format x "%d.%m" 
set xlabel "date"
plot "../output/00_signal_sum.dat" u 2:3 w l ls 1 t "rawdata"


plot "../output/00_signal_sum.dat" u 2:3 w l ls 1 t "before manual filter", "../output/01_manual_sum.dat" u 2:3 w l ls 2 t "after manual filter"

plot "../output/01_manual_sum.dat" u 2:3 w l ls 2 t "before threshold filter", "../output/02_threshold_sum.dat" u 2:3 w l ls 3 t "after threshold filter"

plot "../output/02_threshold_sum.dat" u 2:3 w l ls 3 t "before median filter", "../output/03a_median_sum.dat" u 2:3 w l ls 4 t "after median filter"

plot "../output/03a_median_sum.dat" u 2:3 w l ls 4 t "before smoothing filter", "../output/03b_runmean_sum.dat" u 2:3 w l ls 5 t "after smoothing filter"


plot "../output/03a_median_sum.dat" u 2:3 w l ls 5 t "before osc. threshold", "../output/Filtered_02_masssum.dat" u 2:3 w l ls 6 t "after osc. threshold"

#set xlabel "time on 08.04.2013"
#set output "oscifilter2.png"
#set xrange["2013/04/09_15:48":"2013/04/10_08:12"]
#set yrange[*:*]
#plot "03a_median_sum.dat" u 2:3 w l ls 1 t "before osc. threshold", "04_balanced_sum.dat" u 2:3 w l ls 2 t "after osc. threshold"
