﻿/* WARNING: 
 * Functions are still under testing. Errors are possible.
 Use on personal responsibilty only.
 */

//--- filefunc.h ---
//--- FILE-FUNCTIONS ---
//--- nìtzliche Funktionen zur Bearbeitung von Dateien ---


#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

int nextline(FILE *fp);
int prevline(FILE *fp);
void startofline(FILE *fp);
int printline(FILE *oldfile, FILE *newfile);
int find_col(FILE *data, char *name);
int find_row_min(FILE *data);
void fileopen(FILE *fp, char *filename, char mode);
double readdata(FILE *fp, long row, int col);
void gotoline(FILE *fp, long line);
int gotocol(FILE *fp, int col);
//int shiftline(FILE *fp, long shift); funktioniert nicht! --> siehe evtl. datalines(), hier ist es richtig gemacht.
void copydata(FILE *fin, FILE *fout);
int changefilename(char *oldname, char *newname);
int foldername(char *filename, char *folder);
int changefileending(char *oldname, char *newname);
long datalines(FILE *fp);
long datalinesUnix(FILE *fp);
int nextinput(FILE*fn); /*return 1 when a #-line was passed,2 at EOF, 0 else*/
void checklatex(char *in, char *out);
void readheader(int head[3], FILE *fp, char *filename);
int datcopy(FILE *f_in, FILE *f_out, char *filename); //Achtung: Bei Potentialdateien wird Pascal in hPa umgerechnet (pot=pot/100)
int skip (FILE *fp, int N, char *filename);
double getvalue(FILE *fp);
int numberofcols(FILE *fp);
int numberofcols2(FILE *fp);
double **dmatrix(long n, long m);
char **chmatrix(long n, long m);
bool **boolmatrix(long n, long m);
int printdatatofile(FILE *fp, long *tsec, double **data, long cols, long lines);
int printnonzerotofile(FILE *fp, long *tsec, double **data, long cols, long lines);



    
int nextline(FILE *fp)
{
  int c;
  while ((c=fgetc(fp))!=EOF && c!='\n') ;
  if(c==EOF) return -1;
  else return 0;
}

int prevline(FILE *fp)
{
	int c;
	
	//bis zum Zeilenende zurìck
	do{
		if (fseek(fp, -2L, 1)!=0) return -1;
		c=fgetc(fp);
		//printf("c= %c\n", c);
	}
	while(c!='\n');
		
	
	//an den Zeilenanfang
	do{
		if (fseek(fp, -2L, 1)!=0) return -1;
		c=fgetc(fp);
		//printf("c= %c\n", c);
	}
	while(c!='\n');
	
}
	
	
		

void startofline(FILE *fp)
{
  int c;
  fseek(fp,-1L,1);
  while ((c=fgetc(fp))!='\n')
	fseek(fp,-2L,1);
  return;
}

int printline(FILE *oldfile, FILE *newfile)
{
	char c;
	
	while (((c=fgetc(oldfile))!='\n') && (c!=EOF))
	{
		fputc(c, newfile);
	}
	if(c!=EOF) fputc(c,newfile);
	else
	{
		printf("End of file!\n\n");
		return -1;
	}
	return 0;
}

/* find_col sucht in einem Header nach der Spaltenìberschrift *name, und gibt die Nummer der Spalte zurck.
 * Maximale Zahl von Spalten: 200;
 */

int find_col(FILE *data, char *name)
{
	int i;
	char buffer[50];
	
	fseek(data,0,0);
	
	for(i=1; i<200; i++)
	{
		fscanf(data, "%[^,\n\t]", buffer);
		if(strstr(buffer,name)!=NULL) break;
		fgetc(data);
		//printf("Buffer: %s\n", buffer); getch();
	}
	if (i==200)
		return -1;
	else
		return i;
}

//sucht die Zeile, die den kleinsten Wert in der ersten Spalte enthñlt
//Rìckgabewert: Zeilennummer
int find_row_min(FILE *data)
{
	long i, row;
	double x_min, x;
	
	
	fseek(data,0,0);
	
	//skip header and read first dataset, line =2 (Header=1, Data>=2)
	nextline(data);
	fscanf(data, "%lf", &x_min);
	row = i = 2;
	
	while(!feof(data))
	{
		nextline(data);
		i++;
		
		fscanf(data, "%lf", &x);
		if (feof(data)) break;
		if (x<x_min)
		{
			x_min=x;
			row=i;
		}
	}
	return row;
}
		

void fileopen(FILE *fp, char *filename, char *mode)
{
	fp = fopen(filename, mode);
	
	if(fp==NULL)
	{
		printf("\n\nUNABLE TO OPEN FILE %s\n\n", filename);
		printf("\n\n!!ABORT!!\n\n", filename);
		exit(1);
	}
}

double readdata(FILE *fp, long row, int col)
{
	long i;
	double data;
	
	fseek(fp,0,0);
	
	for(i=1; i<row; i++)
		nextline(fp);
	
	for(i=1; i<col; i++)
		while(fgetc(fp)!='\t');
	
	if ((fscanf(fp, "%lf", &data))==0)
		return -1;
	else return data;
}

void gotoline(FILE *fp, long line)
{
	long i;
	
	fseek(fp, 0,0);
	i=1;
	while(i!=line)
	{
		nextline(fp);
		i++;
	}
}
/* Irgendwie noch fehlerhaft -- funktioniert nicht richtig
int shiftline(FILE *fp, long shift)
{
	long i, s;
	int c;
	
	if(shift<0) {
		s = labs(shift);
		for(i=1; i<=s; i++) {
			fseek(fp,-1L,1);
			while ((c=fgetc(fp))!='\n')
				fseek(fp,-2L,1); //bis Zeilenanfang erreicht
			fseek(fp,-2L,1);
			while ((c=fgetc(fp))!='\n')
				fseek(fp,-2L,1); //Zeilenanfang eine Zeile vorher erreicht
		}
		
		return 0;
	}
	
	else {
		for(i=1; i<=shift; i++) {
			while ((c=fgetc(fp))!=EOF && c!='\n') ;
			if(c==EOF) return -1;
		}
		return 0;
	}
}
	*/

/* gotocol geht in der aktuellen Zeile zur Spalte col. Voraussetzung ist, dass die Spalten durch TABs getrennt sind. */

int gotocol(FILE *fp, int col)
{
	int i;
	char c;
	
	startofline(fp);
	i=1;
	while(i!=col)
	{
		while(((c=fgetc(fp))!='\t') && (c!='\n') && (c!=EOF));
		if(c=='\n' || c==EOF) return -1;
		else i++;
	}
	return 1;
}

void copydata(FILE *fin, FILE *fout)
{
	char c;
	
	fseek(fin, 0L, 0);
	while((c=fgetc(fin))!=EOF)
		fputc(c, fout);
}

int changefilename(char *oldname, char *newname)
{
	int i;
	
	for(i=0; i<256; i++){
		if(oldname[i]=='\0') break;
	}
	
	while (oldname[i]!='/' && i>0)
		i--;
	if(i==0) oldname[i]='\0';
	else oldname[i+1]='\0';
	strcat(oldname, newname);
	
	return 0;
}

int foldername(char *filename, char *folder) //noch nicht getestet
{
	int i, j;
	
	for(i=0; i<256; i++){
		if(filename[i]=='\0') break;
	}
	
	while (filename[i]!='/' && i>0)
		i--;
	if(i==0) {folder[0]='.'; folder[1]='\0';}
	else{
		for(j=0; j<i; j++)
			folder[j]=filename[j];
		folder[i]='\0';
	}
	
	return 0;
}

int changefileending(char *oldname, char *newname)
{
	int i;
	
	for(i=0; i<256; i++){
		if(oldname[i]=='\0') break;
	}
	
	while (oldname[i]!='.')
		i--;
	oldname[i]='\0';
	strcat(oldname, newname);
	
	return 0;
}

long datalines(FILE *fp)
{	
	long lines=0;
	
	while(nextline(fp)!=-1)
		lines++;
	
	//Die Zeilen die nur aus "Return"-Zeichen bestehen, werden wieder abgezogen. Das letzte Return Zeichen (Zeile mit Daten) muss dann wieder dazu gezñhlt werden!
	fseek(fp,-1L,2);
	while (fgetc(fp)=='\n'){
		lines--;
		fseek(fp,-3L,1);
	}
	lines++;
	fseek(fp,0L,0);
	
	return lines;
}

long datalinesUnix(FILE *fp)
{	
	long lines=0;
	
	while(nextline(fp)!=-1)
		lines++;
	
	//Die Zeilen die nur aus "Return"-Zeichen bestehen, werden wieder abgezogen. Das letzte Return Zeichen (Zeile mit Daten) muss dann wieder dazu gezñhlt werden!
	fseek(fp,-1L,2);
	while (fgetc(fp)=='\n'){
		lines--;
		fseek(fp,-2L,1);
	}
	lines++;
	fseek(fp,0L,0);
	
	return lines;
}

int nextinput(FILE*fn) /*return 1 when a #-line was passed,2 at EOF, 0 else*/
{
  int c,m=0;

  while ((c=fgetc(fn))!=EOF && (c==' ' || c=='\n' || c=='\t')) ;
  while (c!=EOF && c=='#') {
    m=1;
    while ((c=fgetc(fn))!=EOF && c!='\n') ;
    while ((c=fgetc(fn))!=EOF && (c==' ' || c=='\t')) ;
  }
  if (c==EOF) return 2;
  ungetc(c,fn);
  return m;
}

void checklatex(char *in, char *out)
{
	int i=0;
	char c;
	
		
	do {
		c=in[i]; 
		if (in[i]=='_') out[i]=' ';
		else out[i]=c;
		i++;
	}
	while(c!='\0');
	
	out[i]=c; //Abschließendes \0 hinzufìgen.
}

/* readheader liest header einer muphi *.bin Datei aus und speicher ihn in head[3] */
void readheader(int head[3], FILE *fp, char *filename)
{
	
	if(fread(head,sizeof(int),3,fp)<3)
	{
		printf("\n\nHeader konnte nicht gelesen werden in Datei %s!\n\n", filename);
		//exit(1);
	}
		
	if (head[0]!=1)
	{
		printf("\n\nAchtung! Kein 1D-File! X-Grid-Anzahl = %d in Datei %s\n\n", head[0], filename);
		//exit(1);
	}
	if (head[2]!=0)
	{
		printf("\n\nAchtung! 3d-file! Z-Grid-Anzahl = %d in Datei %s\n\n", head[2], filename);
		//exit(1);
	}
	
	//printf("\n\nHeader %d %d %d \n\n", head[0], head[1], head[2]);
	
}

/* skip ìberspring N Werte in einer muphi *.bin Datei */
int skip (FILE *fp, int N, char *filename)
{
	int i;
	double x;
	
	for(i=1; i<=N;i++)
	{
	    if(fread(&x,sizeof(double),1,fp)<1)
		{
			printf("\n\nERROR IN READING DATA FILE: %s!\n\n", filename);
			exit(1);
		}
	}
	return 0;
}

/* Datcopy kopiert Datenpunkt aus muphi *.bin Datei in die ìbergeben f_out datei */
int datcopy(FILE *f_in, FILE *f_out, char *filename)
{
	double x;
	
	if(fread(&x,sizeof(double),1,f_in)<1)
		{
			printf("\n\nERROR IN READING DATA FILE: %s!\n\n", filename);
			exit(1);
		}
	
	if(strstr(filename,"pL_")) x/=100.; //Umrechnung in hPa
		
	fprintf(f_out, "%lf\t",x);
}

/* getvalue liest aktuellen Wert aus einer muphi *.bin Datei aus und gibt ihn zurìck */
double getvalue(FILE *fp)
{
	double x;
	
	if(fread(&x,sizeof(double),1,fp)<1)
		{
			printf("\n\ngetvalue: ERROR IN READING DATA FILE1\n\n");
			exit(1);
		}
	
	return x;
}

	
int numberofcols(FILE *fp)
{
	int i=0;
	char buffer[128];
	char c;
	
	do{
		fscanf(fp, "%[^\t,;\n]", buffer);
		c=fgetc(fp);
		//printf("%s\tc=%c\n", buffer,c); getch();
		i++;
	}
	while(c!='\n');
	return i;
}

int numberofcols2(FILE *fp)
{
	int i=0;
	char buffer[128];
	char c;
	
	do{
		fscanf(fp, "%[^\t\n]", buffer);
		c=fgetc(fp);
		//printf("%s\tc=%c\n", buffer,c); getch();
		i++;
	}
	while(c!='\n');
	return i;
}

double **dmatrix(long n, long m)
{
  double **dmat;
  long i,j;

  dmat=(double **)malloc(n*sizeof(double *)); 
  for(i=0;i<n;i++)
    dmat[i]=(double *)malloc(m*sizeof(double));   
  return dmat;
}

char **chmatrix(long n, long m)
{
  char **mat;
  long i,j;

  mat=(char **)malloc(n*sizeof(char *)); 
  for(i=0;i<n;i++)
    mat[i]=(char *)malloc(m*sizeof(char));   
  return mat;
}

bool **boolmatrix(long n, long m)
{
  bool **mat;
  long i,j;

  mat=(bool **)calloc(n,sizeof(bool *)); 
  for(i=0;i<n;i++)
    mat[i]=(bool *)calloc(m,sizeof(bool));   
  return mat;
}

int printdatatofile(FILE *fp, long *tsec, double **data, long cols, long lines)
{
	double tdays;
	long l, i;
	
	time_t now, reftime, time1, ttsec;
	struct tm *myTm;
	myTm = localtime(&now);
	struct tm refTime = {0, 0, 0, 1, 0, (2011-1900), 0, 0, 0};
	reftime = mktime(&refTime);	
	int year, month, day, hour, min, sec;
	
	
	for (l=0; l<lines; l++){
		//calculate time in days and date
		ttsec=(time_t)tsec[l];
		myTm=gmtime(&ttsec);
		
		//read date (da sonst der time1=mktime(myTm)-Befehl die Struktur myTm verñndert!!
		year=(myTm->tm_year +1900);
		month=(myTm->tm_mon +1);
		day= myTm->tm_mday;
		hour=myTm->tm_hour;
		min=myTm->tm_min;
		sec=myTm->tm_sec;
		
		//Zeit in Tagen seit Ref-Time
		time1=mktime(myTm);
		tdays= ((double)(time1-reftime))/86400.;
		//tdays = (double)(tsec[l]-tsec[0])/3600./24.;
		
		//print days
		fprintf(fp, "%lf", tdays);
		
		//print date
		fprintf(fp, "\t%d/%02d/%02d_%02d:%02d:%02d",year,month, day, hour, min, sec);
		//fprintf(fp, "\t%d/%02d/%02d_%02d:%02d:%02d",(myTm->tm_year +1900),(myTm->tm_mon +1), myTm->tm_mday, myTm->tm_hour, myTm->tm_min, myTm->tm_sec);
		
		//print data
		for (i=0; i<cols; i++)
			fprintf(fp, "\t%.5lf", data[i][l]);
		
		//new line
		fprintf(fp, "\n");
	}
	
	return 0;
}

int printnonzerotofile(FILE *fp, long *tsec, double **data, long cols, long lines)
{
	double tdays;
	long l, i;
	int flag;
	
	time_t now, ttsec;
	struct tm *myTm;
	myTm = localtime(&now);
	
	
	for (l=0; l<lines; l++){
		
		//check if there is a nonzero in the dataline
		flag=0;
		for(i=0; i<cols; i++)
			if(data[i][l]!=0.) flag=1;
		
		if(flag){
			
			//print days
			tdays = (double)(tsec[l]-tsec[0])/3600./24.;
			fprintf(fp, "%lf", tdays);
			
			
			//print date
			ttsec=(time_t)tsec[l];
			myTm=gmtime(&ttsec);
			fprintf(fp, "\t%d/%02d/%02d_%02d:%02d:%02d",(myTm->tm_year +1900),(myTm->tm_mon +1), myTm->tm_mday, myTm->tm_hour, myTm->tm_min, myTm->tm_sec);
			
			//print data
			for (i=0; i<cols; i++)
				fprintf(fp, "\t%.5lf", data[i][l]);
			
			//new line
			fprintf(fp, "\n");
		}
	}
	
	return 0;
}
			
void getdate(long lines, long *tsec, char **date)
{
	time_t now, ttsec;
	struct tm *myTm;
	myTm = localtime(&now);
	long l;
	
	for (l=0; l<lines; l++){
		ttsec=(time_t)tsec[l];
		myTm=gmtime(&ttsec);
		sprintf(date[l], "%d/%02d/%02d_%02d:%02d:%02d",(myTm->tm_year +1900),(myTm->tm_mon +1), myTm->tm_mday, myTm->tm_hour, myTm->tm_min, myTm->tm_sec);
	}
}

	
      